;
; **** ZP FIELDS **** 
;
f22 = $22
f24 = $24
f31 = $31
fC0 = $C0
fC1 = $C1
fC2 = $C2
;
; **** ZP ABSOLUTE ADRESSES **** 
;
a00 = $00
a01 = $01
a02 = $02
a03 = $03
a04 = $04
a05 = $05
a06 = $06
a08 = $08
a09 = $09
a0A = $0A
a0B = $0B
a0C = $0C
a0D = $0D
a0E = $0E
a0F = $0F
a10 = $10
a11 = $11
a12 = $12
a13 = $13
a14 = $14
a15 = $15
a16 = $16
a1C = $1C
a1D = $1D
a1E = $1E
a20 = $20
a21 = $21
a22 = $22
a23 = $23
a24 = $24
a25 = $25
a26 = $26
a27 = $27
a28 = $28
a29 = $29
a2A = $2A
a2B = $2B
a2C = $2C
a2D = $2D
a2E = $2E
a2F = $2F
a30 = $30
a31 = $31
a32 = $32
a90 = $90
a91 = $91
a93 = $93
a99 = $99
a9A = $9A
aAC = $AC
aAD = $AD
aAE = $AE
aAF = $AF
aB0 = $B0
aB1 = $B1
aB7 = $B7
aB9 = $B9
aBA = $BA
aBB = $BB
aBC = $BC
aC1 = $C1
aC2 = $C2
aC3 = $C3
aC4 = $C4
aC6 = $C6
aC8 = $C8
aCC = $CC
aCE = $CE
aCF = $CF
aD1 = $D1
aD2 = $D2
aD3 = $D3
aD6 = $D6
aFD = $FD
aFE = $FE
;
; **** ZP POINTERS **** 
;
p09 = $09
pAC = $AC
pAE = $AE
pB0 = $B0
pBB = $BB
pC3 = $C3
pD1 = $D1
pFD = $FD
;
; **** FIELDS **** 
;
f0000 = $0000
f00C2 = $00C2
f0104 = $0104
f1E00 = $1E00
;
; **** ABSOLUTE ADRESSES **** 
;
a00A9 = $00A9
a0277 = $0277
a0278 = $0278
a0279 = $0279
a027A = $027A
a027B = $027B
a027C = $027C
a027D = $027D
a0283 = $0283
a0284 = $0284
a0288 = $0288
a0315 = $0315
a0317 = $0317
a0319 = $0319
a0DA9 = $0DA9
;
; **** POINTERS **** 
;
p02 = $0002
p0014 = $0014
p31 = $0031
p00C1 = $00C1
pC002 = $C002
;
; **** EXTERNAL JUMPS **** 
;
eF682 = $F682
;
; **** PREDEFINED LABELS **** 
;
RAM_CINV = $0314
RAM_CBINV = $0316
RAM_MNINV = $0318
VIA1T2CL = $9118
VIA1T2CH = $9119
VIA1ACR = $911B
VIA1PCR = $911C
VIA1IFR = $911D
VIA1IER = $911E
VIA2PA1 = $9121
VIA2IFR = $912D
VIA2IER = $912E
ROM_CSETMSG = $FF90
ROM_CCLRCHN = $FFCC
ROM_CINCH = $FFCF
ROM_CHROUT = $FFD2
ROM_CLOAD = $FFD5
ROM_CGETL = $FFE4

        ;* = $6000
		* = $0E00
s6000
        JMP j600C

        JMP j603F

s6006   JMP ROM_CINCH ;$FFCF - input character

s6009   JMP ROM_CHROUT ;$FFD2 - output character

j600C   SEI 
        LDA RAM_MNINV
        STA a0D
        LDA RAM_MNINV + 1
        STA a0E
        LDA a6EB2
        LDX a6EB3
        STA RAM_CBINV
        STX a0317
        JSR s6CD9
        LDA #$00
        STA aFD
        STA aFE
        LDA #$80
        JSR ROM_CSETMSG ;$FF90 - enable/disable KERNAL messages
        LDA #$FF
        STA a16
        LDA #$00
        STA a0F
        STA a0C
        STA a2F
        CLI 
		BRK
		;
		;
j603F   jsr s6Cb9
        PLA
        STA a05
        PLA 
        STA a04
        PLA 
        STA a03
        PLA 
        STA a02
        PLA 
        STA a01
        PLA 
        STA a00
        TSX 
        STX a06
        SEC 
        LDA a01
        SBC #$02
        STA a01
        LDA a00
        SBC #$00
        STA a00
        JSR s6CD9
        LDA a16
        CMP #$FF
        BEQ b608A
        LDX a10
        STX aC1
        LDX a11
        STX aC2
        LDY #$00
        JSR s6D6B
        LDA a2B
        BNE b6084
        LDA a2C
        BNE b6087
        BEQ b608A
b6084   JMP j6656

b6087   JMP j6654

b608A   JSR s693E
        LDX #$42
j608F   LDA #$2A
        JSR s6826
        JMP j696A

b6097   LDA #$3F
        JSR s6009
j609C   JSR s693E
        LDA #$2E
        JSR s6009
        LDA #$00
        STA a0B
        STA a27
        STA a2F
b60AC   JSR s689D
        CMP #$2E
        BEQ b60AC
        CMP #$20
        BEQ b60AC
        LDX #$14
b60B9   CMP f6E6D,X
        BNE b60D0
        STA a1C
        TXA 
        ASL 
        TAX 
        LDA f6E82,X
        STA aC1
        LDA f6E83,X
        STA aC2
        JMP (p00C1)

b60D0   DEX 
        BPL b60B9
        BMI b6097
s60D5   LDX #$02
        BNE b60DB
s60D9   LDX #$00
b60DB   LDY fC1,X
        BNE b60E7
        LDY fC2,X
        BNE b60E5
        INC a27
b60E5   DEC fC2,X
b60E7   DEC fC1,X
        RTS 

s60EA   LDA #$00
        STA a21
        JSR s625B
        LDX #$02
b60F3   JSR s693B
        DEX 
        BNE b60F3
        RTS 

s60FA   LDX #$02
b60FC   LDA fC0,X
        PHA 
        LDA f24,X
        STA fC0,X
        PLA 
        STA f24,X
        DEX 
        BNE b60FC
        RTS 

s610A   LDA a25
        LDY a26
        JMP j6115

s6111   LDA aC3
        LDY aC4
j6115   SEC 
        SBC aC1
        STA a24
        TYA 
        SBC aC2
        TAY 
        ORA a24
        RTS 
f6121
        LDA #$00
        BEQ b6127
f6125   LDA #$01
b6127   STA a28
        JSR s67DF
        JSR s693E
        JSR s6111
        JSR s6839
        BCC b6151
b6137   JSR s610A
        BCS b613F
        JMP j61C1

b613F   JSR s6177
        INC aC3
        BNE b6148
        INC aC4
b6148   JSR s6925
        LDY a27
        BNE b6198
        BEQ b6137
b6151   JSR s610A
        CLC 
        LDA a24
        ADC aC3
        STA aC3
        TYA 
        ADC aC4
        STA aC4
        JSR s60FA
b6163   JSR s6177
        JSR s610A
        BCS j61C1
        JSR s60D5
        JSR s60D9
        LDY a27
        BNE b6198
        BEQ b6163
s6177   LDX #$00
        JSR s6D09
        PHA 
        JSR s6D05
        PLA 
        LDY a28
        BEQ b6188
        JSR s6D13
b6188   CMP (p09,X)
        BEQ b6197
s618C   JSR s6810
        JSR s693B
        JSR s68A7
        BEQ b6198
b6197   RTS 

b6198   JMP j609C
f619B
        JSR s67F8
        JSR s6802
        JSR s689D
        JSR s686B
        BCC b61BE
        STA a1E
b61AB   LDX a27
        BNE j61C1
        JSR s6111
        BCC j61C1
        LDA a1E
        JSR s6D17
        JSR s6925
        BNE b61AB
b61BE   JMP b6097

j61C1   JMP j609C
f61C4
        JSR s67F8
        JSR s6802
        JSR s689D
        LDX #$00
        JSR s689D
        CMP #$27
        BNE b61E9
        JSR s689D
b61D9   STA f31,X
        INX 
        JSR s6006
        CMP #$0D
        BEQ b6203
        CPX #$20
        BNE b61D9
        BEQ b6203
b61E9   STX a2A
        JSR s6872
        BCC b61BE
b61F0   STA f31,X
        INX 
        JSR s6006
        CMP #$0D
        BEQ b6203
        JSR s686B
        BCC b61BE
        CPX #$20
        BNE b61F0
b6203   STX a1D
        JSR s693E
b6208   LDX #$00
        LDY #$00
        LDA aC1
        PHA 
        LDA aC2
        PHA 
b6212   JSR s6D3C
        CMP f31,X
        BNE b622C
        JSR s6925
        INX 
        CPX a1D
        BNE b6212
        PLA 
        STA aC2
        PLA 
        STA aC1
        JSR s618C
        BNE b6232
b622C   PLA 
        STA aC2
        PLA 
        STA aC1
b6232   JSR s6925
        LDY a27
        BNE b623E
        JSR s6111
        BCS b6208
b623E   JMP j609C
f6241
        JSR s63FA
b6244   JSR s6111
        BCC b6256
        LDY #$2C
        JSR s60EA
        JSR s62B0
        JSR s68A7
        BNE b6244
b6256   JSR s6559
        BNE b623E
s625B   JSR s6930
s625E   JSR s6810
        JSR s693B
        JSR s6BD3
        LDX #$03
        JSR s6324
        LDX #$06
b626E   CPX #$03
        BNE b6285
        LDY a20
        BEQ b6285
b6276   LDA a29
        CMP #$E8
        JSR s6D3C
        BCS b629B
        JSR s62A8
        DEY 
        BNE b6276
b6285   ASL a29
        BCC b6297
        LDA f6DCA,X
        JSR s6554
        LDA f6DD0,X
        BEQ b6297
        JSR s6554
b6297   DEX 
        BNE b626E
        RTS 

b629B   JSR s62BB
        TAX 
        INX 
        BNE b62A3
        INY 
b62A3   TYA 
        JSR s62A8
        TXA 
s62A8   STX a1D
        JSR s6817
        LDX a1D
        RTS 

s62B0   LDA a20
j62B2   JSR s62BA
        STA aC1
        STY aC2
        RTS 

s62BA   SEC 
s62BB   LDY aC2
        TAX 
        BPL b62C1
        DEY 
b62C1   ADC aC1
        BCC b62C6
        INY 
b62C6   RTS 

s62C7   TAY 
        LSR 
        BCC b62D6
        LSR 
        BCS b62E5
        CMP #$22
        BEQ b62E5
        AND #$07
        ORA #$80
b62D6   LSR 
        TAX 
        LDA f6D79,X
        BCS b62E1
        LSR 
        LSR 
        LSR 
        LSR 
b62E1   AND #$0F
        BNE b62E9
b62E5   LDY #$80
        LDA #$00
b62E9   TAX 
        LDA f6DBD,X
        STA a29
        AND #$03
        STA a20
        TYA 
        AND #$8F
        TAX 
        TYA 
        LDY #$03
        CPX #$8A
        BEQ b6309
b62FE   LSR 
        BCC b6309
        LSR 
b6302   LSR 
        ORA #$20
        DEY 
        BNE b6302
        INY 
b6309   DEY 
        BNE b62FE
        RTS 

b630D   JSR s6D3C
        JSR s62A8
        LDX #$01
b6315   JSR b60F3
        CPY a20
        INY 
        BCC b630D
        LDX #$03
        CPY #$03
        BCC b6315
        RTS 

s6324   TAY 
        LDA f6DD7,Y
        STA a25
        LDA f6E17,Y
        STA a26
b632F   LDA #$00
        LDY #$05
b6333   ASL a26
        ROL a25
        ROL 
        DEY 
        BNE b6333
        ADC #$3F
        JSR s6009
        DEX 
        BNE b632F
        JMP s693B
f6346
        LDA a6EB5
        PHA 
        LDA a6EB4
        PHA 
        LDA #$00
        PHA 
        PHA 
        PHA 
        PHA 
        JMP (p0014)

s6357   STA a1E
        PHA 
b635A   JSR s689D
        JSR s6901
        BNE b635A
        PLA 
s6363   EOR #$FF
        JMP j62B2
f6368
        LDA #$40
f636B = *+1
        BIT @w $00A9
        STA a1E
        JSR s63FA
b6372   LDX a27
        BNE b638D
        JSR s6111
        BCC b638D
        BIT a1E
        BVC b6385
        JSR s6390
        JMP j6388

b6385   JSR s63D0
j6388   JSR s68A7
        BNE b6372
b638D   JMP b6256

s6390   JSR s693E
s6393   LDX #$2E
        LDA #$27
        JSR s6826
        JSR s693B
        JSR s6810
        LDA #$12
        JSR s6009
        LDY #$0C
        LDX #$00
b63A9   JSR s6D09
        AND #$7F
        CMP #$20
        BCS b63B4
        LDA #$2E
b63B4   JSR s6009
        CMP #$22
        BNE b63C5
        LDA #$14
        JSR s6009
        LDA #$22
        JSR s6009
b63C5   JSR s6925
        DEY 
        BNE b63A9
        LDA #$92
        JMP s6009

s63D0   JSR s693E
s63D3   LDX #$2E
        LDA #$3A
        JSR s6826
        JSR s6810
        LDA #$05
        JMP j68EC
f63E2
        JSR s67F8
        LDA #$05
        JSR s6357
        JSR s6559
        JSR s63D0
        LDA #$3A
        STA a0277
        LDA #$00
        JMP j6509

s63FA   JSR s67F8
        STA aC3
        STX aC4
        JSR s6006
        CMP #$0D
        BEQ b640B
        JSR s67FD
b640B   JMP s693E
f640E
        JSR s6849
        STA aC3
        STX aC4
b6415   LDX #$00
        STX a32
b6419   JSR s689D
        CMP #$20
        BEQ b6415
        STA f22,X
        INX 
        CPX #$03
        BNE b6419
b6427   DEX 
        BMI b643B
        LDA f22,X
        SEC 
        SBC #$3F
        LDY #$05
b6431   LSR 
        ROR a32
        ROR a31
        DEY 
        BNE b6431
        BEQ b6427
b643B   LDX #$02
b643D   JSR s6006
        CMP #$0D
        BEQ b6464
        CMP #$3A
        BEQ b6464
        CMP #$20
        BEQ b643D
        JSR s654B
        BCS b645F
        JSR s687F
        LDY aC1
        STY aC2
        STA aC1
        LDA #$30
        STA f31,X
        INX 
b645F   STA f31,X
        INX 
        BNE b643D
b6464   STX a25
        LDX #$00
        STX a27
j646A   LDX #$00
        STX a1E
        LDA a27
        JSR s62C7
        LDX a29
        STX a26
        TAX 
        LDA f6E17,X
        JSR s6531
        LDA f6DD7,X
        JSR s6531
        LDX #$06
b6486   CPX #$03
        BNE b649C
        LDY a20
        BEQ b649C
b648E   LDA a29
        CMP #$E8
        LDA #$30
        BCS b64B3
        JSR s652E
        DEY 
        BNE b648E
b649C   ASL a29
        BCC b64AE
        LDA f6DCA,X
        JSR s6531
        LDA f6DD0,X
        BEQ b64AE
        JSR s6531
b64AE   DEX 
        BNE b6486
        BEQ b64B9
b64B3   JSR s652E
        JSR s652E
b64B9   LDA a25
        CMP a1E
        BEQ b64C2
        JMP j653B

b64C2   JSR s6839
        LDY a20
        BEQ b64F4
        LDA a26
        CMP #$9D
        BNE b64EB
        JSR s6111
        BCC b64DD
        TYA 
        BNE b6542
        LDX a24
        BMI b6542
        BPL b64E4
b64DD   INY 
        BNE b6542
        LDX a24
        BPL b6542
b64E4   DEX 
        DEX 
        TXA 
        LDY a20
        BNE b64EE
b64EB   LDA f00C2,Y
b64EE   JSR s6D6B
        DEY 
        BNE b64EB
b64F4   LDA a27
        JSR s6D6B
        LDY #$41
        STY a0277
        JSR s6559
        JSR s60EA
        JSR s62B0
        LDA #$20
j6509   STA a0278
        LDA aC2
        JSR s655E
        STX a0279
        STA a027A
        LDA aC1
        JSR s655E
        STX a027B
        STA a027C
        LDA #$20
        STA a027D
        LDA #$07
        STA aC6
        JMP j609C

s652E   JSR s6531
s6531   STX a1D
        LDX a1E
        CMP f31,X
        BEQ b6545
        PLA 
        PLA 
j653B   INC a27
        BEQ b6542
        JMP j646A

b6542   JMP b6097

b6545   INX 
        STX a1E
        LDX a1D
        RTS 

s654B   CMP #$30
        BCC b6552
        CMP #$47
        RTS 

b6552   SEC 
        RTS 

s6554   CMP a21
        BNE b655B
        RTS 

s6559   LDA #$91
b655B   JMP s6009

s655E   PHA 
        LSR 
        LSR 
        LSR 
        LSR 
        JSR s682F
        TAX 
        PLA 
        AND #$0F
        JMP s682F
f656C
		PLA
        STA a03
        PHP 
        PLA 
        AND #$EF
        STA a02
        STX a04
        STY a05
        PLA 
        CLC 
        ADC #$01
        STA a01
        PLA 
        ADC #$00
        STA a00
        LDA #$80
        STA a0C
        BNE b65C9
f658A
        PHA 
        TXA 
        PHA 
        TYA 
        PHA 
        TSX 
        LDA f0104,X
        AND #$04
        BNE b6598
        CLI 
b6598   LDY #$30
        LDA (pFD),Y
        STA VIA2IER  ;$912E - interrupt enable register (IER)
        NOP 
        SEI 
        JSR s6CB9
        PLA 
        STA a05
        PLA 
        STA a04
        PLA 
        STA a03
        CLD 
        PLA 
        STA a02
        PLA 
        STA a01
        PLA 
        STA a00
        LDA a0D
        STA RAM_MNINV
        LDA a0E
        STA RAM_MNINV + 1
        JSR s6CD9
        LDA #$20
        STA VIA1IER  ;$911E - interrupt enable register (IER)
b65C9   TSX 
        STX a06
        LDA VIA1IFR  ;$911D - interrupt flag register (IFR)
        STA VIA1IFR  ;$911D - interrupt flag register (IFR)
        CLI 
        BIT a0F
        BPL b65F6
        LDA a10
        STA aC1
        LDA a11
        STA aC2
        LDY #$00
        JSR s6D3C
        STA a16
        LDA #$00
        JSR s6D6B
        BIT a0F
        BVC b65F4
        STA a0F
        JMP j669B

b65F4   STA a0F
b65F6   BIT a0C
        BVC b6612
        LDA a00
        CMP a11
        BNE b6658
        LDA a01
        CMP a10
        BNE b6658
        LDA a2B
        BNE j6656
        LDA a2C
        BNE j6654
        LDA #$80
        STA a0C
b6612   BMI b6629
        LSR a0C
        BCS b661B
        JMP b608A

b661B   LDX a06
        TXS 
        LDA a6EB7
        PHA 
        LDA a6EB6
        PHA 
        JMP j66F5

b6629   JSR s693E
        LDA a01
        LDX a00
        STA aC1
        STX aC2
        JSR s693B
        LDA #$24
        STA a21
        JSR s625E
b663E   JSR ROM_CGETL ;$FFE4 - get a byte from channel
        BEQ b663E
        CMP #$03
        BNE b664A
        JMP j609C

b664A   CMP #$4A
        BNE j669B
        LDA #$01
        STA a0C
        BNE j669B
j6654   DEC a2C
j6656   DEC a2B
b6658   LDA VIA2PA1  ;$9121 - port a I/O register
        CMP #$FA
        BNE j669B
        LDX #$53
        JMP j608F
f6664
        LDA #$00
        BEQ b666E
f6668		
        LDA #$40
        BNE b666E
f666C
        LDA #$80
b666E   STA a0C
        STA a2F
        LDY a12
        STY a2B
        LDY a13
        STY a2C
        JSR s6006
        CMP #$0D
        BEQ b6698
        CMP #$20
        BEQ b6688
        JMP j6729

b6688   JSR s685C
        JSR s68E7
        JSR s6006
        CMP #$0D
        BEQ b6698
        JMP j6729

b6698   JSR s693E
j669B   LDA a16
        CMP #$FF
        BEQ b66D6
        LDX a10
        CPX a01
        BNE b66C4
        LDY a11
        CPY a00
        BNE b66C4
        STY aC2
        STX aC1
        LDX a0C
        BNE b66DA
        LDY #$00
        JSR s6D6B
        LDA #$80
        STA a0F
        LDA #$C0
        STA a0F
        BNE b66DA
b66C4   LDA a0C
        BNE b66DA
        STX aC1
        LDY a11
        STY aC2
        LDY #$00
        LDA #$00
        TAY 
        JSR s6D6B
b66D6   LDA a0C
        BEQ b66F1
b66DA   SEI 
        LDA #$A0
        STA VIA1IER  ;$911E - interrupt enable register (IER)
        LDA #$00
        STA VIA1ACR  ;$911B - aux. control register
        LDA a6EB1
        STA a0319
        LDA a6EB0
        STA RAM_MNINV
b66F1   SEI 
        LDX a06
        TXS 
j66F5   LDA a00
        PHA 
        LDA a01
        PHA 
        LDA a02
        PHA 
        LDA a03
        PHA 
        LDX a04
        LDY a05
        LDA a0C
        ORA a0F
        PHP 
        LDA VIA2IER  ;$912E - interrupt enable register (IER)
        STA a30
        JSR s6CFA
        JSR s6CB9
        PLP 
        BEQ b6727
        LDA #$7F
        STA VIA2IER  ;$912E - interrupt enable register (IER)
        LDA #$09
        STA VIA1T2CL ;$9118 - timer 2 low order (lsb) counter & latch
        LDA #$00
        STA VIA1T2CH ;$9119 - timer 2 high order (msb) counter & latch
b6727   PLA 
        RTI 

j6729   JMP b6097
f672C
        JSR s6849
        STA aC1
        STX aC2
        STA a10
        STX a11
        LDY #$00
        JSR s6D3C
        STA a16
        TYA 
        LDA #$00
        STA a12
        STA a13
        JSR s6859
        STA a12
        STX a13
        JMP j609C
f674F
        JSR s67DF
        STA a2D
        STX a2E
        JSR s6859
        STA a22
        STX a23
        JSR s6859
        STA aAE
        STX aAF
        JSR s6006
        CMP #$0D
        BEQ b6774
        JSR s6006
        CMP #$57
        BNE b6774
        INC a21
b6774   JSR s6839
b6777   LDX a27
        BNE b6793
        JSR s610A
        BCC b6793
        LDY a21
        BNE b679E
        JSR s6D3C
        JSR s62C7
        TAX 
        LDA f6DD7,X
        BNE b6796
        JSR s60EA
b6793   JMP j609C

b6796   LDY a20
        CPY #$02
        BNE b67D7
        BEQ b67A0
b679E   STY a20
b67A0   DEY 
        SEC 
        JSR s6D3C
        TAX 
        SBC a22
        INY 
        JSR s6D3C
        SBC a23
        BCC b67D7
        DEY 
        JSR s6D3C
        STA a08
        LDA aAE
        SBC a08
        INY 
        JSR s6D3C
        STA a08
        LDA aAF
        SBC a08
        BCC b67D7
        DEY 
        CLC 
        TXA 
        ADC a2D
        JSR s6D6B
        INY 
        JSR s6D3C
        ADC a2E
        JSR s6D6B
b67D7   JSR s6925
        DEY 
        BPL b67D7
        BMI b6777
s67DF   JSR s6849
        STA aC3
        STX aC4
        JSR s6859
        STA a25
        STX a26
        JSR s689D
s67F0   JSR s685C
b67F3   STA aC1
        STX aC2
        RTS 

s67F8   JSR s6849
        BCS b67F3
s67FD   JSR s685C
        BCS b6805
s6802   JSR s6859
b6805   STA aC3
        STX aC4
        RTS 

        JSR s60FA
        JMP s6859

s6810   LDA aC2
        JSR s6817
        LDA aC1
s6817   PHA 
        LSR 
        LSR 
        LSR 
        LSR 
        JSR s682F
        TAX 
        PLA 
        AND #$0F
        JSR s682F
s6826   PHA 
        TXA 
        JSR s6009
        PLA 
        JMP s6009

s682F   CLC 
        ADC #$F6
        BCC b6836
        ADC #$06
b6836   ADC #$3A
        RTS 

s6839   LDX #$02
b683B   LDA fC0,X
        PHA 
        LDA fC2,X
        STA fC0,X
        PLA 
        STA fC2,X
        DEX 
        BNE b683B
        RTS 

s6849   LDA #$00
        STA a2A
b684D   JSR s689D
        CMP #$20
        BEQ b684D
        JSR s687F
        BCS b6861
s6859   JSR s689D
s685C   JSR s686B
        BCC b6868
b6861   TAX 
        JSR s686B
        BCC b6868
        RTS 

b6868   JMP b6097

f686C   =*+$01
s686B   LDA #$00
        STA a2A
        JSR s689D
s6872   CMP #$20
        BNE s687F
        JSR s689D
        CMP #$20
        BNE b688B
        CLC 
        RTS 

s687F   JSR s6892
        ASL 
        ASL 
        ASL 
        ASL 
        STA a2A
        JSR s689D
b688B   JSR s6892
        ORA a2A
        SEC 
        RTS 

s6892   CMP #$3A
        PHP 
        AND #$0F
        PLP 
        BCC b689C
        ADC #$08
b689C   RTS 

s689D   JSR s6006
        CMP #$0D
        BNE b689C
        JMP j609C

s68A7   LDA a91
        CMP #$FE
        BNE b68B4
        PHP 
        JSR ROM_CCLRCHN ;$FFCC - restore default devices
        STA aC6
        PLP 
b68B4   RTS 

b68B5   JSR s68BE
        BIT VIA2IFR  ;$912D - interrupt flag register (IFR)
        BMI b68B5
        RTS 

s68BE   JSR s68A7
        BNE b68CE
        JSR s68CF
        LDA #$03
        STA a9A
        LDA #$00
        STA a99
b68CE   RTS 

s68CF   PHP 
        SEI 
        LDA VIA1PCR  ;$911C - peripheral control register for handshaking
        ORA #$02
        STA VIA1PCR  ;$911C - peripheral control register for handshaking
        LDA a6EAE
        STA RAM_CINV
        LDA a6EAF
        STA a0315
        PLP 
        RTS 

s68E7   STA a01
        STX a00
        RTS 

j68EC   STA a1E
        LDY #$00
b68F0   JSR s693B
        JSR s6D3C
        JSR s6817
        JSR s6925
        DEC a1E
        BNE b68F0
        RTS 

s6901   JSR s686B
        BCC b6912
        LDX #$00
        JSR s6D17
        CMP (p09,X)
        BEQ b6912
        JMP b6097

b6912   JSR s6925
        DEC a1E
        RTS 

s6918   LDA #<p02
        STA aC1
        LDA #>p02
        STA aC2
        LDA #$05
        INC a0B
        RTS 

s6925   INC aC1
        BNE b692F
        INC aC2
        BNE b692F
        INC a27
b692F   RTS 

s6930   TYA 
        PHA 
        JSR s693E
        PLA 
s6936   LDX #$2E
        JSR s6826
s693B   LDA #$20
s693E   =*+$01
        BIT a0DA9
        JMP s6009
f6943
        LDA aC8
        CMP #$02
        BCC j696A
        JSR s6006
        CMP #$42
        BNE j696A
        LDA a16
        CMP #$FF
        BEQ j696A
        LDX a10
        LDY a11
        STX aC1
        STY aC2
        LDY #$00
        JSR s6D6B
        LDA #$FF
        STA a16
        JMP j609C

j696A   LDX #$00
b696C   LDA f6E57,X
        JSR s6009
        INX 
        CPX #$16
        BNE b696C
        JSR s693E
        LDX #$2E
        LDA #$3B
        JSR s6826
        LDA a00
        JSR s6817
        LDA a01
        JSR s6817
        JSR s6918
        JSR j68EC
        DEC a0B
b6993   JMP j609C

        JMP b6097
f6999
        JSR s6849
        JSR s68E7
        JSR s6918
        STA a1E
b69A4   JSR s689D
        JSR s6901
        BNE b69A4
        DEC a0B
        BEQ b6993
f69B0
        SEI 
        JSR s6CFA
        LDX a06
        TXS 
        JSR s6CB9
        JMP (pC002)

b69BD   JMP b6097
f69C0
        LDY #$01
        STY aBA
        STY aB9
        DEY 
        STY aB7
        STY a90
        STY a93
        LDA #>p31
        STA aBC
        LDA #<p31
        STA aBB
b69D5   JSR s6006
        CMP #$20
        BEQ b69D5
        CMP #$0D
        BEQ b69FA
        CMP #$22
b69E2   BNE b69BD
b69E4   JSR s6006
        CMP #$22
        BEQ b6A11
        CMP #$0D
        BEQ b69FA
        STA (pBB),Y
        INC aB7
        INY 
        CPY #$10
b69F6   BEQ b69BD
        BNE b69E4
b69FA   LDA a1C
        CMP #$4C
b69FE   BNE b69E2
        LDA #$00
        JSR ROM_CLOAD ;$FFD5 - load after call SETLFS,SETNAM
        JSR b68B5
        LDA a90
        AND #$10
b6A0C   BNE b69FE
        JMP j609C

b6A11   JSR s6006
        CMP #$0D
        BEQ b69FA
        CMP #$2C
b6A1A   BNE b6A0C
        JSR s686B
        AND #$0F
b6A21   BEQ b69F6
        CMP #$03
        BEQ b6A21
        STA aBA
        JSR s6006
        CMP #$0D
        BEQ b69FA
        CMP #$2C
b6A32   BNE b6A1A
        JSR s67F0
        JSR s6006
        CMP #$2C
b6A3C   BNE b6A32
        JSR s685C
        STA aAE
        STX aAF
b6A45   JSR s6006
        CMP #$20
        BEQ b6A45
        CMP #$0D
b6A4E   BNE b6A3C
        LDA a1C
        CMP #$53
        BNE b6A4E
        JSR s693E
        JSR eF682
        JMP j609C
f6a5F
        LDA a2F
        BNE b6A67
        LDA aC6
        BNE b6A6D
b6A67   PLA 
        TAY 
        PLA 
        TAX 
        PLA 
        RTI 

b6A6D   LDA a0277
        CMP #$11
        BEQ b6A77
        JMP j6B0D

b6A77   LDA aD6
        CMP #$16
        BNE b6A67
        LDA aD1
        STA aC3
        LDA aD2
        STA aC4
        LDA #$17
        STA a2B
b6A89   LDY #$01
        JSR s6C73
        CMP #$3A
        BEQ b6AAB
        CMP #$2C
        BEQ b6AAB
        CMP #$27
        BEQ b6AAB
        DEC a2B
        BEQ b6A67
        SEC 
        LDA aC3
        SBC #$16
        STA aC3
        BCS b6A89
        DEC aC4
        BNE b6A89
b6AAB   STA a1C
        JSR s6C2F
        BCS b6A67
        LDA a1C
        CMP #$3A
        BEQ b6ACD
        CMP #$27
        BNE b6AED
        CLC 
        LDA #$0C
        ADC aC1
        STA aC1
        BCC b6AC7
        INC aC2
b6AC7   JSR s6390
        JMP j6AFC

b6ACD   CLC 
        LDA aC1
        ADC #$05
        STA aC1
        BCC b6AD8
        INC aC2
b6AD8   JSR s693E
        LDX #$2E
        LDA #$3A
        JSR s6826
        JSR s6810
        LDA #$05
        JSR j68EC
        JMP j6AFC

b6AED   JSR s6BD3
        JSR s62B0
        LDA #$00
        STA a21
        LDY #$2C
        JSR s625B
j6AFC   LDA #$00
        STA aC6
        STA a2F
        STA a27
        JSR s6559
        JSR s693E
        JMP b6A67

j6B0D   CMP #$91
        BEQ b6B14
        JMP b6A67

b6B14   LDA aD6
        BEQ b6B1B
        JMP b6A67

b6B1B   LDA aD1
        STA aC3
        LDA aD2
        STA aC4
        LDA #$17
        STA a2B
b6B27   LDY #$01
        JSR s6C73
        CMP #$3A
        BEQ b6B49
        CMP #$2C
        BEQ b6B49
        CMP #$27
        BEQ b6B49
        DEC a2B
        BEQ b6B50
        CLC 
        LDA aC3
        ADC #$16
        STA aC3
        BCC b6B27
        INC aC4
        BNE b6B27
b6B49   STA a1C
        JSR s6C2F
        BCC b6B53
b6B50   JMP b6A67

b6B53   LDA a1C
        CMP #$3A
        BEQ b6B71
        CMP #$27
        BNE b6B90
        JSR s6BDB
        SEC 
        LDA aC1
        SBC #$0C
        STA aC1
        BCS b6B6B
        DEC aC2
b6B6B   JSR s6393
        JMP j6B82

b6B71   JSR s6BDB
        SEC 
        LDA aC1
        SBC #$05
        STA aC1
        BCS b6B7F
        DEC aC2
b6B7F   JSR s63D3
j6B82   LDA #$00
        STA aC6
        STA a2F
        STA a27
        JSR s6C2A
        JMP b6A67

b6B90   JSR s6BDB
        LDA aC1
        LDX aC2
        STA aC3
        STX aC4
        LDA #$10
        STA a2B
b6B9F   SEC 
        LDA aC3
        SBC a2B
        STA aC1
        LDA aC4
        SBC #$00
        STA aC2
b6BAC   JSR s6BD3
        JSR s62B0
        JSR s6111
        BEQ b6BBD
        BCS b6BAC
        DEC a2B
        BNE b6B9F
b6BBD   INC a20
        LDA a20
        JSR s6363
        LDX #$00
        STX a21
        LDA #$2C
        JSR s6936
        JSR s625E
        JMP j6B82

s6BD3   LDX #$00
        JSR s6D09
        JMP s62C7

s6BDB   LDA #$00
        STA aAE
        LDA a0288
        AND #$02
        ORA #$95
        STA aAF
        STA aB1
        LDY a0288
        INY 
        STY aAD
        STY aC4
        LDA #$00
        STA aAC
        LDA #$16
        STA aC3
        STA aB0
        LDY #$E3
        LDX #$02
b6C00   LDA (pAC),Y
        STA (pC3),Y
        LDA (pAE),Y
        STA (pB0),Y
        DEY 
        BNE b6C00
        DEX 
        BEQ b6C20
        LDA (pAC),Y
        STA (pC3),Y
        LDA (pAE),Y
        STA (pB0),Y
        DEC aAD
        DEC aC4
        DEC aAF
        DEC aB1
        BNE b6C00
b6C20   LDX #$15
        LDA #$20
b6C24   STA f1E00,X
        DEX 
        BPL b6C24
s6C2A   LDA #$13
        JMP s6009

s6C2F   CPY #$16
        BNE b6C35
        SEC 
        RTS 

b6C35   JSR s6C73
        CMP #$20
        BEQ s6C2F
        DEY 
        JSR s6C5E
        TAX 
        JSR s6C5E
        STA aC1
        STX aC2
        LDA #$FF
        STA a2F
        STA aCC
        LDA aCF
        BEQ b6C5C
        LDA aCE
        LDY aD3
        STA (pD1),Y
        LDA #$00
        STA aCF
b6C5C   CLC 
        RTS 

s6C5E   JSR s6C73
        JSR s6892
        ASL 
        ASL 
        ASL 
        ASL 
        STA a2A
        JSR s6C73
        JSR s6892
        ORA a2A
        RTS 

s6C73   LDA (pC3),Y
        INY 
        AND #$7F
        CMP #$20
        BCS b6C7E
        ORA #$40
b6C7E   RTS 
f6C7F
        JSR s6849
        CPX #$04
        BCC b6CA9
        STA aFD
        STX aFE
        STA a0283
        STX a0284
        STA aC3
        STX aC4
        LDY #$00
b6C96   LDA #$55
        STA (pC3),Y
        CMP (pC3),Y
        BNE b6CA9
        LDA f0000,Y
        STA (pC3),Y
        INY 
        BNE b6C96
        JMP j609C

b6CA9   STX aC3
        ORA aC3
        BNE b6CB6
        STA aFD
        STX aFE
        JMP j609C

b6CB6   JMP b6097

s6CB9   PHA 
        TXA 
        PHA 
        TYA 
        PHA 
        LDA aFE
        BEQ b6CD3
        LDY #$00
b6CC4   LDA f0000,Y
        TAX 
        LDA (pFD),Y
        STA f0000,Y
        TXA 
        STA (pFD),Y
        INY 
        BNE b6CC4
b6CD3   PLA 
        TAY 
        PLA 
        TAX 
        PLA 
        RTS 

s6CD9   LDA RAM_CINV
        LDX a0315
        CMP a6EAE
        BNE b6CE9
        CPX a6EAF
        BEQ b6CF9
b6CE9   STA a14
        STX a15
        LDA a6EAE
        LDX a6EAF
        STA RAM_CINV
        STX a0315
b6CF9   RTS 

s6CFA   LDA a14
        STA RAM_CINV
        LDA a15
        STA a0315
        RTS 

s6D05   LDX #$02
        BNE b6D0B
s6D09   LDX #$00
b6D0B   JSR s6D23
        LDX #$00
        LDA (p09,X)
        RTS 

s6D13   LDX #$02
        BNE b6D19
s6D17   LDX #$00
b6D19   PHA 
        JSR s6D23
        PLA 
        LDX #$00
        STA (p09,X)
        RTS 

s6D23   LDA fC2,X
        BNE b6D35
        CLC 
        LDA aFD
        ADC fC1,X
        STA a09
        LDA aFE
        ADC fC2,X
        STA a0A
        RTS 

b6D35   STA a0A
        LDA fC1,X
        STA a09
        RTS 

s6D3C   PHP 
        PLA 
        AND #$EF
        PHA 
        STY a08
        TYA 
        CLC 
        ADC aC1
        STA a09
        LDA #$00
        ADC aC2
        STA a0A
        CMP #$01
        BCS b6D63
        LDA a0B
        BNE b6D63
        LDA a09
        ADC aFD
        STA a09
        LDA a0A
        ADC aFE
        STA a0A
b6D63   LDY #$00
        LDA (p09),Y
        LDY a08
        PLP 
        RTS 

s6D6B   PHA 
        JSR s6D3C
        STY a08
        LDY #$00
        PLA 
        STA (p09),Y
        LDY a08
        RTS 

f6D79   RTI 

        .BYTE $02,$45,$03,$D0,$08,$40,$09,$30
        .BYTE $22,$45,$33,$D0,$08,$40,$09,$40
        .BYTE $02,$45,$33,$D0,$08,$40,$09,$40
        .BYTE $02,$45,$B3,$D0,$08,$40,$09,$00
        .BYTE $22,$44,$33,$D0,$8C,$44,$00,$11
        .BYTE $22,$44,$33,$D0,$8C,$44,$9A,$10
        .BYTE $22,$44,$33,$D0,$08,$40,$09,$10
        .BYTE $22,$44,$33,$D0,$08,$40,$09,$62
        .BYTE $13,$78,$A9
f6DBD   .BYTE $00,$21,$81,$82,$00,$00,$59,$4D
        .BYTE $91,$92,$86,$4A,$85
f6DCA   .BYTE $9D,$2C,$29,$2C,$23,$28
f6DD0   .BYTE $24,$59,$00,$58,$24,$24,$00
f6DD7   .BYTE $1C,$8A,$1C,$23,$5D,$8B,$1B,$A1
        .BYTE $9D,$8A,$1D,$23,$9D,$8B,$1D,$A1
        .BYTE $00,$29,$19,$AE,$69,$A8,$19,$23
        .BYTE $24,$53,$1B,$23,$24,$53,$19,$A1
        .BYTE $00,$1A,$5B,$5B,$A5,$69,$24,$24
        .BYTE $AE,$AE,$A8,$AD,$29,$00,$7C,$00
        .BYTE $15,$9C,$6D,$9C,$A5,$69,$29,$53
        .BYTE $84,$13,$34,$11,$A5,$69,$23,$A0
f6E17   .BYTE $D8,$62,$5A,$48,$26,$62,$94,$88
        .BYTE $54,$44,$C8,$54,$68,$44,$E8,$94
        .BYTE $00,$B4,$08,$84,$74,$B4,$28,$6E
        .BYTE $74,$F4,$CC,$4A,$72,$F2,$A4,$8A
        .BYTE $00,$AA,$A2,$A2,$74,$74,$74,$72
        .BYTE $44,$68,$B2,$32,$B2,$00,$22,$00
        .BYTE $1A,$1A,$26,$26,$72,$72,$88,$C8
        .BYTE $C4,$CA,$26,$48,$44,$44,$A2,$C8
f6E57   .BYTE $0D,$20,$20,$20,$50,$43,$20,$20
        .BYTE $53,$52,$20,$41,$43,$20,$58,$52
        .BYTE $20,$59,$52,$20,$53,$50
		; command table
		;       A,  B,  C,  D,  F,  G,  H,  I
f6E6D   .BYTE $41,$42,$43,$44,$46,$47,$48,$49
		;       L,  M,  
        .BYTE $4C,$4D,$4E,$51,$52,$53,$54,$57
        .BYTE $58,$2C,$3A,$3B,$45
f6E82   .BYTE <f640E	;$0E
f6E83   .BYTE >f640E	;$64 - A
		.BYTE <f672C	;$2C
		.BYTE >f672C	;$67 - B
		.BYTE <f6121	;$21
		.BYTE >f6121	;$61 - C
		.BYTE <f6241	;$41
		.BYTE >f6241	;$62 - D
		.BYTE <f619B	;$9B
        .BYTE >f619B	;$61 - F
		.BYTE <f6664	;$64
		.BYTE >f6664	;$66 - G
		.BYTE <f61C4	;$C4
		.BYTE >f61C4	;$61 - H
		.BYTE <f6368	;$68
		.BYTE >f6368	;$63 - I
		.BYTE <f69C0	;$C0
        .BYTE >f69C0	;$69 - L
		.BYTE <f636B	;$6B
		.BYTE >f636B	;$63 - M
		.BYTE <f674F	;$4F
		.BYTE >f674F	;$67
		.BYTE <f6668	;$68
		.BYTE >f6668	;$66
		.BYTE <f6943	;$43
        .BYTE >f6943	;$69
		.BYTE <f69C0	;$C0
		.BYTE >f69C0	;$69
		.BYTE <f6125	;$25
		.BYTE >f6125	;$61
		.BYTE <f666C	;$6C
		.BYTE >f666C	;$66
		.BYTE <f69B0	;$B0
        .BYTE >f69B0	;$69
		.BYTE <f640E	;$0E
		.BYTE >f640E	;$64
		.BYTE <f63E2	;$E2
		.BYTE >f63E2	;$63
		.BYTE <f6999	;$99
		.BYTE >f6999	;$69
		.BYTE <f6C7F	;$7F
        .BYTE >f6C7F	;$6C
		.BYTE <s6000	;$00
		.BYTE >s6000	;$60
a6EAE   .BYTE <f6346	;$46
a6EAF   .BYTE >f6346	;$63
a6EB0   .BYTE <f658A
a6EB1   .BYTE >f658A
a6EB2   .BYTE <j603F	;$3F
a6EB3   .BYTE >j603F	;$60
a6EB4   .BYTE <f6a5F	;$5F
a6EB5   .BYTE >f6a5F	;$6A
a6EB6   .BYTE <f656C	;$6C
a6EB7   .BYTE >f656C	;$65
		.BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$AA,$AA,$AA
        .BYTE $AA,$AA,$AA,$AA,$AA,$4D,$4F,$4E
        .BYTE $54,$52,$52,$4F,$4C,$2E,$41,$4D
        ;.BYTE $00
